#!/usr/bin/perl
# The above line is a throw back to my Unix days...ignore it.
#
# Description:
#
# A Perl script to create an HTML photo album of .GIF. and .JPG files.  It
# specifically looks for all graphic files in the directory specified on the
# URL and lists them and includes the text from corresponding .TXT files.  
# This is all done in table format, creating an index (or album) of the graphics 
# in the directory.
#
# The directory specified must be a directory under the DocumentRoot defined
# in the Web Server's SRM.CFG file.
#
# The directory to album is specified as PATH on the URL line
#
# Example: http://server:port/perl/album.pl?PATH=/images gives an album of the 
# "images" directory under the document root.
# 
# Descriptions of the graphic files are given by creating a text file whose 
# name is the same as the graphic file, except with an extension of .TXT.  
# The description file must be in the same directory as the graphic file.  
# The description will be displayed on the album page.
#
# This may not be the most efficient script in the world <g>, but its a good example.

# Standard opening commands for a Web Server Perl CGI script
require("cgilib.pl");
&PrintHeader; print "\n\n";
&ReadParse;

# Set up the necessary variables
($path   = ("$in{PATH}/" or "/")) =~ s|//|/|g;		#The path from the CGI data
$host   = "$ENV{SERVER_NAME}:$ENV{SERVER_PORT}"; 	#The Web Server's host name
($dir   = "$ENV{VSERVER_ROOT}docs$path/") =~ s|//|/|g;	#The real directory (e.g. SYS:WEB...)
@types = ("GIF", "JPG");				#The valid extensions to search for

#--------- HTML Document Setup --------------
print "<html>\n";
print "<title>Album of $path</title>\n";
print "<body bgcolor=#ffffff>\n";
print "<h3>Album of $path</h3>\n";
print "Click on the file name of an image to fully view it.<hr>\n";

#-------- Build Table -------------------
# Set up the table for this .GIF/.JPG
print "<table border=0>\n";
opendir(DIR, $dir) || print "<br>Error: Unable to open directory $dir. $!\n";
# Loop throught he .GIF and .JPG files in the directory
foreach $file (sort(readdir(DIR))) {
  $name = substr($file, 0, length($file)-4);
  $ext = substr($file, length($file)-3, 3);
  if (grep(/$ext/, @types) > 0) {
    print "<tr>\n";
    print "  <td valign=top align=left>\n";
    # Display text description
    if (-e "$dir$name.TXT") {
      open(DESC, "$dir$name.TXT");
      while (!eof(DESC)) { print <DESC>; }
    } else {
      print "No description available.\n";
    }
    print "  </td>\n";
    # Display picture
    print "  <td>\n";
    print "    <a href=$path$file><img src=$path$file border=0 height=50></a>\n";
    print "  </td>\n";
    print "  </td>\n";
    print "</tr>\n";
  }
}
# When all the files are listed, close the directory
closedir(DIR);
# Close the table
print "</table><p>\n";

#---------- HTML Document Wrap-up ------------
print "</body>\n";
print "</html>\n";
