# NWS 3.0 Perl5 test script: files.pl
# 2/07/97 jmerrill
# 2/24/97 jmerrill, updated to convert special HTML characters
# To test file access, opening, closing, implicit closes, globbing, etc.

require("cgilib.pl");
print &PrintHeader;
&ReadParse;

$url="http://$ENV{SERVER_NAME}:$ENV{SERVER_PORT}/perl$ENV{SCRIPT_NAME}";
$file=($in{FILE} || "sys:/web");

print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD// HTML 3.2 Final//EN">
<HTML>
<HEAD><TITLE>NWS 3.0 Perl5 test script: files.pl</TITLE></HEAD>
<BODY>
<FORM METHOD=GET ACTION="$url">
  Path:
  <INPUT TYPE=TEXT NAME=FILE VALUE="$file" SIZE=80>
  <INPUT TYPE=SUBMIT VALUE="Go">
</FORM>
EOF

if ($file) {
  # Test the file test operators -e, -r, -w, -d, -f, -T.
  if (-e $file) {
    print "\"$file\" is a ";
    # Say whether the file is readable or not.
    (-r $file && print "readable, ") || print "non-readable, ";
    # Say whether the file is writeable or not.
    (-w $file && print "writeable, ") || print "non-writeable, ";
    # Say whether the file is a regular file or not.
    (-f $file && print "regular, ") || print "irregular, ";
    # Say whether the file is a text file or not.
    (-T $file && print "text, ") || print "non-text, ";
    # Say whether the file is actually a directory.
    (-d $file && print "directory.\n") || print "file.\n";
    print "<HR>\n";

    # File Tests
    if (-T $file) {
      print "The contents are:<PRE>\n";
      open(FILE, $file);
      foreach $line (<FILE>) {
        $line =~ s/&/&amp\;/g;
        $line =~ s/</&lt\;/g;
        $line =~ s/>/&gt\;/g;
        print $line;
      }
      close(FILE); 
      print "</PRE>\n";
    }

    # Directory Tests
    if (-d $file) {
      ($dir="$file/") =~s|\\|/|g;
      $dir=~s|//|/|g; # make sure the directory ends with a '/'
      print "<TABLE BORDER><TR VALIGN=TOP><TD><B>Directory</B></TD>\n";
      print "</TR><TR VALIGN=TOP><TD>\n";
      # opendir()/readdir() method
      opendir(DIR, "$dir") || print "failed to open directory $dir\n";
      foreach $dirfile (sort readdir(DIR)) {
        print "<A HREF=\"$url?FILE=$dir$dirfile\">$dirfile</a><br>\n";
        # Test opening each file with same file handle.  This will test the implicit close.
        # If a file is opened and another file is opened with the same file handle,
        # the first file handle is implicitly closed by Perl.  The last one remains open.
        (-f "$dir$dirfile") and open(FILE, "$dir$dirfile")
      }
      close(FILE); 
      closedir(DIR);
      print "</TD></TR></TABLE>\n";
    }
  }
  else {
    print "\"$file\" doesn't exist!\n";
  }
}

print "</PRE></BODY></HTML>\n";
