#!/usr/bin/perl
#
# THIS SCRIPT IS NOT SUPPORTED BY NOVELL IN ANY WAY.  YOU MAY USE IT, MODIFY IT, OR WHATEVER
# AT YOUR OWN RISK.
#
# WARNING: Beware of line wrapping when reading this.  Depending on where you get it you may need to clean up the line wrapping. For example, this is one continuous line, with no carriage returns.
#
# This script searches all files in a directory for occurances of a user specified search string.
# Subdirectories are not searched or listed (listing them is the role of the DirectoryIndex file).
#
# The directory to be searched is specified by PATH.  For example:
#   http://myserver:80/perl/search.pl?PATH=/dir1/dir2
# will search "SYS:WEB\DOCS\DIR1\DIR2" on a default installation.  This will NOT work with Aliases. This
# is a change from the way it worked in the past.  The change was necessary due to the way the LoadableModule
# line is implemented (which is used by Perl5).  
#
# The search form passes information to the CGI script using the GET method so that bookmarks
# can be set to include the search criteria.
#
# Since this is written in Perl, the search string can contain regular expressions.  For example,
# searching for "exec" will find "exec", "execute", "executive", "old-exec", etc.  But searching for "exec\b"
# says to search for "exec" followed by a word boundry.  It will find "exec", "old-exec", etc.
#
# Each word entered in the search string (separated by spaces) is searched for separately.  If any
# one of the words is not found, the hit counter for that file is set to 0.  Otherwise, the hit 
# counter will increment for each file found.
#

# Standard opening commands for a Web Server Perl CGI script
require("cgilib.pl");
&PrintHeader; print "\n\n";
&ReadParse;

# Set up variables
@srch   = split(' ', $in{SEARCH});			#The words to search for
$path   = ("$in{PATH}" or "/");				#The path from the CGI data
$host   = "$ENV{SERVER_NAME}:$ENV{SERVER_PORT}"; 	#The Web Server's host name
($dir    = "$ENV{VSERVER_ROOT}docs$path/") =~ s|//|/|g;	#The real directory (e.g. SYS:WEB...)
($pdir  = $dir) =~ s|(.*/)[^/]*/|$1|;               	#The real parent directory
($rdir   = "$path/") =~ s|//|/|g;		       	#The relative directory (e.g. /IMAGES)
($rpdir = $rdir) =~ s|(.*/)[^/]*/|$1|;              	#The relative parent directory
(($in{CASE} eq "on") && ($caseflg="CHECKED")) || ($caseflg=""); #Case sensitive ("CHECKED") or not ("")
(($in{SHOWALL} eq "on") && ($showflg="CHECKED")) || ($showflg=""); #Show all files ("CHECKED") or not ("")

# Display the search form
print "<head><title>Search: $rdir</title></head><body bgcolor=#ffffff><img src=\"/images/search.gif\">\n";
&print_form;

# Add the elipses directory to the directory list.
if (length($rdir) > 1) {
  $dirlist = "<a href=\"http://$host/perl$ENV{SCRIPT_NAME}?PATH=$rpdir&CASE=$in{CASE}&SHOWALL=$in{SHOWALL}&SEARCH=$in{SEARCH}\">/..</a><br>\n";
}
# Go through each file/subdirectory in the search directory
opendir(DIR, "$dir") || &errout("Unable to open directory $dir.\n");
$found=$total=0;
foreach $file (sort(readdir(DIR))) {
  if (-d "$dir$file") {     
    # If the file is a directory, add to the directory list.
    $dirlist.="<a href=\"http://$host/perl$ENV{SCRIPT_NAME}?PATH=$rdir$file&CASE=$in{CASE}&SHOWALL=$in{SHOWALL}&SEARCH=$in{SEARCH}\">/$file</a><br>\n";
  } else {
    # If the file is not a directory, search it for the search string.
    $hits=$inc=0;
    ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)=stat("$dir$file");
    # If it is a text file read the file in and search it
    if (-T "$dir$file") {
      open(FILE, "$dir$file") || &errout("Open of $dir$file failed.\n");
      sysread(FILE, $text, $size) || &errout("Read of $dir$file failed.\n");
      close(FILE); # Always make sure you close your files and directories.
      # Search for each word.  If one word is not found, end search.
      SEARCH: foreach $srch (@srch) {
        (!$caseflg && ($inc=$text=~s/$srch//gi)) || ($inc=$text=~s/$srch//g);
        if ($inc) {
          $hits+=$inc;
        } else {
          $hits=0;
          last SEARCH;
        }
      }
      # Add to the hits list
      if ($hits || $showflg) { 
        @hits[$found++] = "$hits  <a href=\"http://$host$rdir$file\">$file</a><br>\n";
        $total+=$hits;
      }
    } elsif ($showflg) {
      # If the file isn't a text file, but the showflg is set, add to the hits list
      @hits[$found++] = "-  <a href=\"http://$host$rdir$file\">$file</a> (non-text)<br>\n";
    }
  }
}
closedir(DIR); # Always make sure you close your files and directories.

print "<table border=1 cellpadding=5 cellspacing=5><tr><td valign=top>\n";
print "<p><b>\"$in{SEARCH}\" was found $total times in $found file(s).</b></p>\n";
print sort {$b <=> $a} @hits;
print "</td><td valign=top>\n";
print "<p><b>Subdirectories</b></p>\n";
print "$dirlist"; 
print "</td></tr></table>\n";

# Send HTML common footer
print "</body></html>\n";

# ============= Subroutines Follow ===============

# Subroutine which sets up the form to get search criteria.
sub print_form {
  print <<"ENDFORM";
  <form method=\"get\" action=\"/perl$ENV{SCRIPT_NAME}\">
  <table>
  <tr>
    <td valign=top>Search path:</td>
    <td valign=top><input type=\"text\" name=\"PATH\" value=\"$rdir\" maxlength=255 size=50></td>
  </tr><tr>
    <td valign=top>Search string:</td>
    <td valign=top><input type=\"text\" name=\"SEARCH\" value=\"$in{SEARCH}\" maxlength=255 size=50></td>
  </tr><tr>
    <td valign=top><input type=\"submit\" value=\"Search\"></td>
    <td>Case sensitive:<input type=\"checkbox\" name=\"CASE\" $caseflg>
        Show all files:<input type=\"checkbox\" name=\"SHOWALL\" $showflg></td>
  </tr>
  </table>
  </form>
ENDFORM
} # end of sub print_form

sub errout {
  $err = $!;
  $errmsg = shift;
  print "<br>Error: $errmsg$err";
#  die "search.pl Error: $errmsg$err";
} # end of sub errout
